//---------------------------------------------------------------------
// Event_Cmd: onCmd get's called when you say /event [Cmd]
// You can then check ifCmd to make sure it's the right Cmd and restrictions and stuff
// ifCmd then triggers onCmdCalled if it's the right
//---------+-----------------------------------------------------------
// by Mold |
//---------+


//Register the events
registerInputEvent(fxDtsBrick,"onCmd","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent(fxDtsBrick,"onCmdCalled","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerInputEvent(fxDtsBrick,"onCmdRestricted","Self fxDtsBrick\tPlayer Player\tClient GameConnection\tMinigame Minigame");
registerOutputEvent(fxDtsBrick,"ifCmd","string 100 100\tlist Unrestricted 0 SameMinigame 1 OnlyMe 2 bl_idAllow 3 bl_idDeny 4 NoTrust 5 BuildTrust 6 FullTrust 7 Distance 8\tstring 100 100\tstring 8 30",1);
$Event_Cmds::onCmdIndex = inputEvent_GetInputEventIdx("onCmd");
$Event_Cmds::ifCmdIndex = outputEvent_GetOutputEventIdx("ifCmd");

//Event functions
function fxDtsBrick::onCmd(%brick, %Cmd, %client)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = %client.player;
	$inputTarget_Client = %client;
	$inputTarget_Minigame = getMinigameFromObject(%client);
	%brick.lastCmd = %Cmd;
	%brick.lastCmdClient = %client;
	%brick.processInputEvent("onCmd",%client);
}
function fxDtsBrick::onCmdCalled(%brick, %client)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = %client.player;
	$inputTarget_Client = %client;
	$inputTarget_Minigame = getMinigameFromObject(%client);
	%brick.processInputEvent("onCmdCalled",%client);
}
function fxDtsBrick::onCmdRestricted(%brick, %client)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = %client.player;
	$inputTarget_Client = %client;
	$inputTarget_Minigame = getMinigameFromObject(%client);
	%brick.processInputEvent("onCmdRestricted",%client);
}
function fxDtsBrick::onCmdTooFar(%brick, %client)
{
	$inputTarget_Self = %brick;
	$inputTarget_Player = %client.player;
	$inputTarget_Client = %client;
	$inputTarget_Minigame = getMinigameFromObject(%client);
	%brick.processInputEvent("onCmdTooFar",%client);
}
function fxDtsBrick::ifCmd(%brick, %Cmd, %restriction, %subrestrict, %whichones, %client)
{
	if(%brick.lastCmd $= "" || %brick.lastCmdClient !$= %client || !isObject(%client))
		return;
	if(%Cmd $= "")
		return;
	if(%brick.lastCmd $= %Cmd)
	{
		switch(%restriction)
		{
		case 0: //Unrestricted
			%brick.TriggerSubCmdEvents(%whichones, 0, %client);
		case 1: //Same minigame
			if(isObject(getBrickGroupFromObject(%brick).client.minigame) && getBrickGroupFromObject(%brick).client.minigame == %client.minigame)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 2: //Only Me
			if(getBrickGroupFromObject(%brick).client == %client)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 3: //BL_ID Allow
			if(getWordCount(%subrestrict) >= 1)
			{
				for(%i = 0;%i<getWordCount(%subrestrict);%i++)
				{
					if(isInt(getWord(%subrestrict,%i)) && %client.BL_ID $= getWord(%subrestrict,%i))
					{
						%brick.TriggerSubCmdEvents(%whichones, 0, %client);
						%nofail = 1;
					}
				}
			}
			if(!%nofail)
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 4: //BL_ID Deny
			if(getWordCount(%subrestrict) >= 1)
			{
				for(%i = 0;%i<getWordCount(%subrestrict);%i++)
				{
					if(isInt(getWord(%subrestrict,%i)) && %client.BL_ID $= getWord(%subrestrict,%i))
						%fail = 1;
				}
			}
			if(!%fail)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 5: //No Trust
			if(getTrustLevel(%client, %brick) == 0)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);	
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 6: //Build Trust
			if(getTrustLevel(%client, %brick) >= 1)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 7: //Full Trust
			if(getTrustLevel(%client, %brick) >= 2)
				%brick.TriggerSubCmdEvents(%whichones, 0, %client);
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);
		case 8: //Distance Limit
			if(isObject(%client.player) && isInt(%subrestrict))
			{
				%pos1 = %client.player.getPosition();
				%pos2 = %brick.getPosition();
				if(VectorDist(%pos1, %pos2) <= (%subrestrict / 2))
					%brick.TriggerSubCmdEvents(%whichones, 0, %client);
				else
					%brick.TriggerSubCmdEvents(%whichones, 1, %client);
			}
			else
				%brick.TriggerSubCmdEvents(%whichones, 1, %client);				
		}
	}
}

function fxDtsBrick::TriggerSubCmdEvents(%brick, %whichones, %fail, %client)
{
	if(isObject(%client))
	{
		//The part to trigger specific events was more or less copied from VCE
		if(getWordCount(%whichones) != 2)
		{
			if(%fail == 0)
				%brick.onCmdCalled(%client);
			else if(%fail == 1)
				%brick.onCmdRestricted(%client);
			return;
		}
		%start = getWord(%whichones,0);
		%end = getWord(%whichones,1);
		if(!isInt(%end))
		{
			if(%fail == 0)
				%brick.onCmdCalled(%client);
			else if(%fail == 1)
				%brick.onCmdRestricted(%client);
			return;
		}
		if(!isInt(%start) && isInt(%end))
		{
			switch$(%start)
			{
				case "<":
					%start = 0;
					%end--;
				case "<=":
					%start = 0;
				case ">":
					%start = %end++;
					%end = %brick.numEvents;
				case ">=":
					%start = %end;
					%end = %brick.numEvents;
				case "==":
					%start = %end;
				case "!=":
					%ignore = %end;
				default:
					%start = 0;
					%end = %brick.numEvents;
			}
		}
		if(%start < 0)
			%start = 0;
		if(%end > %brick.numEvents)
			%end = %brick.numEvents;
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(((%i < %start || %i > %end) && %ignore $= "") || (%ignore == %i && %ignore !$= ""))
			{
				if(%fail == 0)
				{
					if(%brick.eventInput[%i] $= "onCmdCalled")
					{
						%oldEnabled[%i] = %brick.eventEnabled[%i];
						%brick.eventEnabled[%i] = 0;
					}
				}
				else if(%fail == 1)
				{
					if(%brick.eventInput[%i] $= "onCmdRestricted")
					{
						%oldEnabled[%i] = %brick.eventEnabled[%i];
						%brick.eventEnabled[%i] = 0;
					}
				}
			}
		}
		if(%fail == 0)
			%brick.onCmdCalled(%client);
		else if(%fail == 1)
			%brick.onCmdRestricted(%client);
		for(%i=0;%i<%brick.numEvents;%i++)
		{
			if(%oldEnabled[%i] !$= "")
				%brick.eventEnabled[%i] = %oldEnabled[%i];
		}
	}
}
	

// Package
package Event_Cmds
{
	//We have to add the brick to list when the event is added to a brick
	function serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4)
	{
		if(%input == $Event_Cmds::onCmdIndex)
		{
			$Event_CmdsBrickList = addItemToList($Event_CmdsBrickList, %client.wrenchBrick);
		}
		if(%input == $Event_Cmds::onCmdCalledIndex && %output == $Event_Cmds::ifCmdIndex)
			return; //Nope, we don't want to make creating loops so easy!
		return Parent::serverCmdAddEvent(%client, %delay, %input, %target, %a, %b, %output, %par1, %par2, %par3, %par4);
	}
	//We have to remove the brick from list when the event is removed from a brick 
	function serverCmdClearEvents(%client)
	{
		if(hasItemOnList($Event_CmdsBrickList,%client.wrenchBrick))
		{
			$Event_CmdsBrickList = removeItemFromList($Event_CmdsBrickList, %client.wrenchBrick);
		}
		Parent::serverCmdClearEvents(%client);
	}
	function fxDtsBrick::onDeath(%brick)
	{
		if(hasItemOnList($Event_CmdsBrickList,%brick))
		{
			$Event_CmdsBrickList = removeItemFromList($Event_CmdsBrickList, %brick);
		}
		Parent::onDeath(%brick);
	}
};
activatePackage(Event_Cmds);


//List functions found in Event_Minigame
function addItemToList(%string,%item)
{
	if(hasItemOnList(%string,%item))
		return %string;

	if(%string $= "")
		return %item;
	else
		return %string SPC %item;
}
function hasItemOnList(%string,%item)
{
	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
			return 1;
	}
	return 0;
}
function removeItemFromList(%string,%item)
{
	if(!hasItemOnList(%string,%item))
		return %string;

	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
		{
			if(%i $= 0)
				return getWords(%string,1,getWordCount(%string));
			else if(%i $= getWordCount(%string)-1)
				return getWords(%string,0,%i-1);
			else
				return getWords(%string,0,%i-1) SPC getWords(%string,%i+1,getWordCount(%string));
		}
	}
}

//-----
//Set Cmd function with RTB pref
//-----

//We have to register the pref
if(isFile("add-ons/system_returntoblockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/ServerCOntrol.cs");
	RTB_registerPref("Cmd function name", "Cmd Events", "$Pref::Event_Cmds::FunctionName", "string 100", "Event_Cmds", "eventcmd", 0, 1,"UpdateCmdEventsFunction");
}	//Host-only pref

//Function setting function
function UpdateCmdEventsFunction()
{
	//We don't want to overwrite stuff
	if(!hasItemOnList($EventCmdsFunctionNameList, $Pref::Event_Cmds::FunctionName) && isFunction("servercmd" @ $Pref::Event_Cmds::FunctionName))
	{
		$Pref::Event_Cmds::FunctionName = $Pref::Event_Cmds::LastFunctionName;
		return;
	}
	
	//We don't want cryptic functions or syntax errors
	//and we don't want things like
	// e(%client,%cmd){eval(%cmd);}// as a command name!!!
	%filter = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_";
	for(%i=0;%i<strlen($Pref::Event_Cmds::FunctionName);%i++)
	{
		%char = strUpr(getSubStr($Pref::Event_Cmds::FunctionName, %i, 1));
		if(strPos(%filter, %char) == -1)
			%error = 1;
	}
	if(%error)
	{
		$Pref::Event_Cmds::FunctionName = $Pref::Event_Cmds::LastFunctionName;
		return;
	}
		
	//We have to add the function name to the list
	$EventCmdsFunctionNameList = addItemToList($EventCmdsFunctionNameList, $Pref::Event_Cmds::FunctionName);
	
	//We have to remove the last function
	if(isFunction("servercmd" @ $Pref::Event_Cmds::LastFunctionName))
	{
		%eval = "";
		%eval = %eval @ "function servercmd";
		%eval = %eval @ $Pref::Event_Cmds::LastFunctionName;
		%eval = %eval @ "(){}";
		eval(%eval);
	}
	
	//We have to set the pref for the next change
	$Pref::Event_Cmds::LastFunctionName = $Pref::Event_Cmds::FunctionName;
	
	//We have to add a new function
	%eval = "";
	%eval = %eval @ "function servercmd";
	%eval = %eval @ $Pref::Event_Cmds::FunctionName;
	%eval = %eval @ "(%client, %Cmd, %param1, %param2, %param3, %param4, %param5)";
	%eval = %eval @ "{";
	//Set client variables for VCE checks of additional params
	%eval = %eval @ "for(%i = 1;%i < 6; %i++)";
	%eval = %eval @ "{";
	%eval = %eval @ "if(%param[%i] !$= \"\"){%client.param[%i] = %param[%i];}else{%client.param[%i] = \"\";}";
	%eval = %eval @ "}";
	%eval = %eval @ "for(%i=0;%i<getWordCount($Event_CmdsBrickList);%i++)";
	%eval = %eval @ "{";
	%eval = %eval @ "%brick = getWord($Event_CmdsBrickList,%i);";
	%eval = %eval @ "if(isObject(%brick))";
	%eval = %eval @ "{";
	%eval = %eval @ "%brick.onCmd(%Cmd, %client);";
	%eval = %eval @ "}";
	%eval = %eval @ "}";
	%eval = %eval @ "}";
	eval(%eval);
}

//We have to create the function when starting server
UpdateCmdEventsFunction();

//We have to register the VCE values for the params
%error = ForceRequiredAddOn("Event_Variables");
if(%error == $Error::AddOn_Disabled)
{
   echo("VCE was force loaded to support Event_Commands.");
}
if(%error == $Error::AddOn_NotFound)
{
   echo("VCE not found. Additional parameters of Event_Commands won't work.");
}
else
{
	for(%i = 1;%i < 6;%i++)
	{
		registerSpecialVar(GameConnection,"ceparam" @ %i,"%this.param" @ %i);
	}
}

//----+
//End |
//----+